# MapDisplay Changelog

# 4

## 4.7.1

- implement replacement for function missing in csp versions before 0.1.80-p346

## 4.7

- implement "MapDisplay Progress" widget (similar to RaceLab's FlatMap)
- detect cars in pit lane and allow to hide them or scale them relatively to the marker size
- make position marker image configurable
  - pin (default)
  - circle
  - flat circle (no gradient background, similar to circles in v2.X and v3.X)
- make position marker size independent from car rotation (driving up- or downwards was previously making the circles smaller)
- fix draw order of cars to have leading cars on top
- exclude inactive (disconnected) cars from the position calculation

## 4.6

- implement workaround for missing online properties (best laps) to calculate positions in time based sessions correctly
  - will only use laps started and completed while being connected

## 4.5.1

- fix "Remove" buttons for CSP non-preview version (0.1.78/0.1.79) to show text buttons

## 4.5

- add "Drivers" config to make it possible to hide certain drivers (driver name based)
- make stopped cars threshold configurable
- replaced all "Remove" buttons with icons
- clicking on "Update" in Map Generation will now always generate a new image, even if none of the parameters changed (useful if e.g. the ai file changed)

## 4.4

- add workarounds to correct driver lap counts and race positions (especially in online races)
- add additional session reset detections, to correctly reset data

## 4.3

- added Map Generation shape optimizations, to better use the available space while keeping them rotatable
- implement settings to be able to reduce Full Map margins
- workaround for tryParse not using default parameter to handle settings errors correctly

## 4.2

- hide positions if they are incorrect (e.g. in some replays)
- support UTF-8 with BOM for car tag json
- catch errors when parsing class tags

## 4.1

- fix issue with pinned apps no longer being clickable, pin cannot be removed
  - uses a blank text as workaround

## 4.0

- full Lua re-implementation
  - live update of generated map
  - live class configurations
  - copy/pase for settings between widgets
  - removed track recordings (alternative is create AI line and use general process from there)
  - no custom traffic names/tags, only auto detection

# 3

## 3.8

- display full maps always in same scale, to prevent visual differences in line widths. Will not optimally use space

## 3.7

- add CSP version warning to mini map
- update create_png to support comments in DRS zones and sector definitions

## 3.6

- fix focused car not being displayed in front of others in replays
- generated map not being correctly selected on newly opened tracks (happened only occasionally)
- hide legend app background even when focused to allow better configuration of custom background in settings

## 3.5

- implement color legends as separate Lua apps

## 3.4.1

- fix always re-generating images, even though they were correctly available

## 3.4

- improve the memory usage of create_png.exe
  - will draw maps in separate tiles, one after another to have less in memory in parallel

## 3.3

- add batch image generation scripts to generate images prior to starting the game
- use pit lane for map generation boundary calculation (fix cut off pit lanes)
- add UI info for app version info in Content Manager

## 3.2

- add class position number mode
- position map for camera perspective rather than selected driver
- allow disabling map generation
- cache generated map image only on success and regenerate on next start on failure
- fix switching to autogenerated maps
- correctly hide text after startup
- move generated track configs into other file (track_config.ini)

## 3.1

- add option to configure circle text color as well using ":" separator
- make stopped car threshold configurable, so that it can be used as slow vehicle identifier as well
- fix to really only render cars that should be visible

## 3.0

- add second widget MapDisplayMini
  - mini map that has the focused driver in the center and rotates with the car
  - update map generation scripts to allow for adaptive render sizes based on track size, to have consistent details
    - quality configurable for the Mini Map as "Px per meter" directly influencing the output resolution. Bigger is better quality
  - multiple cropping modes available (quadratic filling the app, fading circle)
  - CSP recommended >= 0.1.78
    - cropping is not supported with CSP < 0.1.76 and is buggy for 0.1.76 and 0.1.77 (last driver will not have a number displayed)
- only generate new track images if the configuration has changed or the image is missing
- updated window sizing icons so that the lens could be used for actual zooming in the Mini Map

# 2

## 2.11

- make create_png more robust against invalid configuration files

## 2.10

- add sector and drs indicators to generated map
  - only possible if /data/overlays.ini (for sectors) and /data/drs_zones.ini (for drs)
    exists for the given track layout
- increase standing still threshold to 1m/s
- updated App Icon
- updated create_png.exe compilation, should not trigger anti viruses anymore (but is 50% bigger)

## 2.9

- implement automatic map generation based on fast_lane.ai
  - different modes to automatically select this generated map or not
  - configurable line and outline width, pit and start/fin colors

## 2.8

- implement flag colored map mode (configurable)
- make spectated car color configurable
- make all position based colors configurable
- fix issues with track recordings after rotation implementation
- make app compatible with CSP >= 0.1.73 again (was >= 0.1.76)

## 2.7

- implement map rotation (configurable in game, stored per map)
- implement show stopped car modes, show/hide/custom color
- update border alignments, make window square per default

## 2.6

- implement initials mode for circle text
- fix traffic by name detection for reconnecting online traffic

## 2.5

- make position mode leader highlight configurable
- fix settings encoding issue for specific system languages (e.g. Simplified Chinese)

## 2.4

- allow to configure different modes for the number to be displayed (position, carId, none)
- implement free roam color mode
  - detects traffic cars by driver name or vehicle tag
  - different visualization for traffic, allow to hide number

## 2.3

- use only one white base circle image and color it dynamically within the code
- implement tag based classes and class colors (configurable)
- allow selection of color mode: based on position or based on class
  - hotfix to correctly save this

## 2.2

- add config defaults for Content Manager (resets configuration on install)
- update window scaling to store only integers
- align buttons
- add option to scale circles
- correctly extract global variables in code, might fix random initialization error

## 2.1

- display spectated car on top of others instead of carId 0
- add option to hide stopped cars
- implement interactive window sizing

## 2.0

- replace arrows with circles containing the position of the car
- requires CSP now (as `ac.ext_glFontUse` and related functions are used)
- adjusted colors used for circles, kept the logic to identify color classes
- removed color schemes (as only one set of circle colors available for now)

# 1

## 1.16

- potential fix for the disappearing app issue reported by many users. Thanks to RD user @AdderSwim
- add arrow_size_factor to .ini file

## 1.15

- respect the new focusedCar() API to change the perspective to the currently spectated car
- new coloring scheme for non-race sessions (based on out-lap information)
- fix very high CPU usage when recording maps of long tracks
- changed default resolution of generated maps to 2048 x 2048 pixel
- fix display red line when recording a map (is not cut anymore)

## 1.14

- AC 1.3 / 64 bit compatibility

## 1.13

- another workaround for dangling cars in MP (after a player has disconnected)
- support the track configurations introduced in AC 1.1
- improve invariance against influences from other apps (e.g., older versions of helicorsa)

## 1.12

- handling of silverstone-national
- fix "dangling" cars of AC 1.0RC

## 1.11

- experimental workarounds for issues observed with AC 0.22
- handling of nurburgring-sprint

## 1.10

- update for AC 0.22
- color scheme is now restored correctly from ini file (saved between runs)

## 1.9

- add more general options in the .ini file
- adjustable png sizes
- better responses when recordings are started or saved
- use packages as a namespace for required modules, avoiding side-effects from other apps

## 1.8

- automatic .png generation when a track is recorded

## 1.7

- compatibility with AC 0.20

## 1.6

- add some user feedback in the title bar (so the user can see what's going on)
- optimizations in the track display (when using a .pickled / point list file). The ac limit on the number of points shall be reached much later now (nord_snoopy works ok).
- save user settings in map_display.ini file
- when a recording is saved, it is immediately used (no need to click lower left icon)
- fix possibility to use vallelunga-club map in vallelunga and silverstone-international map in silverstone
- new icons from Wattie (thanks a lot!)
- eyecandy versions of maps for built-in tracks (thanks snjper for the idea with the green inside!)
- register_map.py: add possibility (code only) for extended fits
- register_map.py: runtime optimizations
- register_map.py: add possibility to generate .png files from .pickled files

## 1.5

- just a fix for the icon paths

## 1.4

- read the track's map.ini file to get the necessary parameters for displaying (now every track supported by the builtin app should be supported by this app as well)
- the .reg.pickled files in data/ are obsolete now and they are not read anymore (they have been removed)
- interactive toggling between different versions of map displays (using content/tracks/<trackname>/map*.png and apps/python/map_display/data/<trackname>*.png and apps/python/map_display/data/<trackname>\*.pickled)
- support different color schemes for coloring the opponents (two by now), interactive toggling
- implemented but disabled due to severe issues in the python api: interactive zooming
- fix possible ac issues when the acMain function throws an exception
- gui mode for recording track maps (there is a record, discard and save button)
- display the so-far recorded track
- possibility for A-B tracks in point list (.pickled) mode, draw the closing line only when reasonably close

## 1.3

- fix session type changes and resets (if possible)
- prefer png's in data folder with same name then the pickle file over the ones in the content folder
- introduce workarounds.py for implementing workarounds around issues in current ac python api
- add profiling info in py_log.txt file

## 1.2

- app-icon
- transparent title bar (using hacks from snjper, put link to icon hack in initial post)
- try using TyreHeadingVector instead of velocity vector (seems that the API is not yet implemented, so fall back using velocity is used)
- move pickled files to data subdirectory
- opponent coloring in qualifying and training, for the moment, the color is constantly yellow (instead of random before)
- development mode (prevent track recording in user mode to ensure that the .pickled files are sane, see development_mode)
- alpha rendering for car arrows (see alphaCarArrows variable)

## 1.1

- if possible, use the map png's supplied with ac itself to display the map
- this needs an initial registering process with the script register_map.py
- cars are shown as arrows now (if they move) pointing in the direction of their velocity vector
- colors of opponent cars changed according to car state (ahead, behind, overlapped, ...)

## 1.0

- Initial version
