Driver = class('Driver')

function Driver:initialize(id) -- constructor
  self.id = id
  self.name = ""
  self.initials = ""

  self.updateTimer = 0
end

function Driver:update(dt)
  self.updateTimer = self.updateTimer + dt

  if self.updateTimer > 1 then
    local name = ac.getDriverName(self.id)
    if name ~= self.name then
      self.name = name
      self.initials = self:calculateInitials()
    end

    self.updateTimer = 0
  end
end

function Driver:calculateInitials()
  local initials, matched = self.name:gsub("(%w).*%s(%w).*", "%1%2")
  return matched > 0 and initials or self.name:sub(0, 2)
end
