local defaults = stringify({
    circleTextMode = CircleTextMode.Position,
    circleImage = CircleImage.Pin,
    circleRadius = 12,
    colorByFlag = true,
    -- spec configs
    specCircleRadius = 14,
    specColor = rgbm(0, 1, 1, 1),
    specTextColor = rgbm(0, 0, 0, 1),
    -- stopped car configs
    stoppedCarsMode = StoppedCarsMode.Transparent,
    stoppedCarsAlpha = 0.5,
    stoppedCarsColor = rgbm(0.25, 0.25, 0.25, 0.75),
    stoppedCarsTextColor = rgbm(1, 1, 1, 0.75),
    stoppedCarsThreshold = 1.0,
    -- pit lane --
    pitLaneMode = ProgressPitLaneMode.Scale,
    pitLaneOffsetScale = 75,
    -- color mode
    circleColorMode = CircleColorMode.Position,
    circleColorStatic = rgbm.new('#CF6800'),
    circleColorStaticText = rgbm.colors.white,
    -- position based colors
    positionHighlightLeader = true,
    positionHighlightColor = rgbm.new('#AE3838'),
    positionHighlightTextColor = rgbm.colors.white,
    positionBehindColor = rgbm.new('#199A19'),
    positionBehindTextColor = rgbm.colors.white,
    positionBehindLappedColor = rgbm.new('#206CB7'),
    positionBehindLappedTextColor = rgbm.colors.white,
    positionAheadColor = rgbm.new('#CF6800'),
    positionAheadTextColor = rgbm.colors.white,
    positionAheadLappedColor = rgbm.new('#A3A300'),
    positionAheadLappedTextColor = rgbm.colors.white,
    -- debug
    drawDebugLines = false,
})

---@return table
return function()
    ---@diagnostic disable-next-line: return-type-mismatch
    return stringify.parse(defaults, {})
end
